(     Title:  Conditional display and
              ANSI color terminal support for testers
       File:  tester-display.fs
    Authors:  Krishna Myneni, David N. Williams
    License:  Public Domain
    Version:  1.1.1
    Revised:  November 30, 2010

The date above may reflect cosmetic changes not logged here.

Version 1.1.1
30Nov10 * Removed conditional CR initializer.

Version 1.1.0
13Nov10 * Extracted from former ttester-display.fs 1.0.6.
	* Added host detection.
	* Added conditional CR initializer.
24Nov10 * Replaced #27 by 27 in ESC definition.

This file assumes that the VERBOSE variable has been defined,
for example, by loading ttester or ttester-xf beforehand.
)

s" FORTH-NAME" ENVIRONMENT? dup [IF]
  drop s" pfe" compare 0=
[THEN] CONSTANT PFE-HOST

s" gforth" environment? dup [IF]
  ( s flag) nip nip
[THEN] CONSTANT GFORTH-HOST

s" IFORTH" environment? dup [IF]
  ( flag) drop
[THEN] CONSTANT IFORTH-HOST

\ Turn this off if it causes a problem with your terminal.
[UNDEFINED] ANSI-TERMINAL-COLORS [IF]
true CONSTANT ANSI-TERMINAL-COLORS
[THEN]

ANSI-TERMINAL-COLORS [IF]  \ based on Krishna Myneni's code
  BASE @ decimal
  [UNDEFINED] ESC [IF] 27 CONSTANT esc [THEN]
  IFORTH-HOST [IF]
    : bs-emits  ( u -- )  0 ?DO bs emit LOOP ;
    : normal-text ( -- )  esc emit ." [0m"  3 bs-emits ; 
    : red-text    ( -- )  esc emit ." [31m" 4 bs-emits ;
    : green-text  ( -- )  esc emit ." [32m" 4 bs-emits ;
    : blue-text   ( -- )  esc emit ." [34m" 4 bs-emits ;
  [ELSE]
    : normal-text ( -- )  esc emit ." [0m" ; 
    : red-text    ( -- )  esc emit ." [31m" ;
    : green-text  ( -- )  esc emit ." [32m" ;
    : blue-text   ( -- )  esc emit ." [34m" ;  
  [THEN]
  BASE !
[ELSE]
  : normal-text ( -- ) ; immediate
  : red-text    ( -- ) ; immediate
  : green-text  ( -- ) ; immediate
  : blue-text   ( -- ) ; immediate
[THEN]

: ?.    ( x -- )  VERBOSE @ IF . ELSE drop THEN ;
: ?.cr  ( -- )    VERBOSE @ IF cr THEN ;
: ?.(   ( -- )    VERBOSE @ IF postpone .( ELSE postpone ( THEN ;
: ?type ( s -- )  VERBOSE @ IF type ELSE 2drop THEN ;

[UNDEFINED] PARSE-AREA@ [IF]
: parse-area@  ( -- unparsed.s )  source >in @ /string ; [THEN]

: ?."   ( ccc<"> -- )  \ a version of Krishna Myneni's COMMENT
(
Parse the next string in the parse area with double quote as
trailing delimiter.  If VERBOSE is true, print the resulting
string in blue, and if no quote is present, emit a trailing CR. 
Otherwise, discard the parsed string.  A version of Krishna
Myneni's COMMENT with optional CR.
) 
  parse-area@ nip
  [char] " parse
  VERBOSE @ IF
    dup >r blue-text type normal-text
    r> = IF cr THEN
  ELSE 2drop drop THEN ;
